# Ubuntu Continuous Integration Engine
# Copyright 2013 Canonical Ltd.

# This program is free software: you can redistribute it and/or modify it under
# the terms of the GNU General Public License version 3, as published by the
# Free Software Foundation.

# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranties of MERCHANTABILITY,
# SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License along with
# this program.  If not, see <http://www.gnu.org/licenses/>.

from dput.changes import Changes


class ChangesProcessor:
    """Class to parse, validate and upload source files to the datastore."""

    def __init__(self, changes_filepath):
        # Needs to be provided with the full path to the changes file.
        self.changes_filepath = changes_filepath
        self.files_to_upload = []
        self.changes = None

    def parse(self):
        try:
            self.changes = Changes(self.changes_filepath)
        except IOError, exc:
            print "File not found: %s" % self.changes_filepath
            raise exc
        except Exception, exc:
            print "Something went wrong: %s" % exc
            raise exc

    def validate_files(self, check_signature=False):
        changes = self.changes
        try:
            # We don't care if signatures fail for now
            changes.validate(check_signature=check_signature)
            self.files_to_upload = changes.get_files()
            self.files_to_upload.append(changes.get_changes_file())
        except IOError, exc:
            # File not found. Aborting upload
            raise exc

    def upload_files(self):
        for file_ in self.files_to_upload:
            # Do something
            pass

    def process(self):
        self.parse()
        self.validate_files()
        self.upload_files()
